/* ljdata.c	-- PalmLJ data manipulation
 * $Id: ljdata.c,v 1.1 2001/04/15 19:31:10 kvance Exp $
 * Copyright (C) 2001 Kev Vance <kvance@tekktonik.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <stdlib.h>

#include "palmlj.h"

UserRecord *GetUserRecord(UserRecord * first, UInt16 record)
{
    int i;
    UserRecord *r = first;

    for (i = 0; i != record; i++) {
	if (r->next == NULL)
	    return NULL;
	r = r->next;
    }

    return r;
}

AccessRecord *GetAccessRecord(AccessRecord * first, UInt16 record)
{
    int i;
    AccessRecord *a = first;

    for (i = 0; i != record; i++) {
	if (a->next == NULL)
	    return NULL;
	a = a->next;
    }

    return a;
}

UserRecord *DelUserRecord(UserRecord * r)
{
    AccessRecord *a;
    UserRecord *s;
    int i;

    for (i = r->accessCount; i != 0; i--) {
	a = GetAccessRecord(r->accessRecord, i - 1);
	free(a);
    }
    s = r->next;
    free(r);
    return s;
}

