/* palmlj.h	-- PalmLJ structures for hotsync
 * $Id: palmlj.h,v 1.1 2001/04/15 19:31:10 kvance Exp $
 * Copyright (C) 2000-2001 Kev Vance <kvance@tekktonik.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef _PALMLJ_H
#define _PALMLJ_H 1

#include <sys/types.h>

#define idCreator	'PaLJ'
#define idDatabase	'LJdb'

#define Int16	int16_t
#define UInt16	u_int16_t
#define Int32	int32_t
#define UInt32	u_int32_t
#define Char	char

typedef struct DateTimeType {
        Int16 second;
        Int16 minute;
        Int16 hour;
        Int16 day;
        Int16 month;
        Int16 year;
        Int16 weekDay;          // Days since Sunday (0 to 6)
} DateTimeType;
typedef struct AccessRecord {
    Char user[64];
    struct AccessRecord *next;
} AccessRecord;
typedef struct UserRecord {	/* current version = 1 */
    Char user[64];
    Char passwd[32];
    Char name[128];
    Int16 accessCount;
    struct AccessRecord *accessRecord;
    struct UserRecord *next;
} UserRecord;
typedef struct MoodRecord {
    UInt16 id;
    Char name[15];
    struct MoodRecord *next;
} MoodRecord;
typedef struct LJPrefs {
    UInt16 version;	/* current version = 3 */
    UInt16 lastUser;
    UInt16 lastAccess;
    UInt16 connectType;
} LJPrefs;

typedef struct Entry {
	UInt16 version;	/* current version = 1 */
	DateTimeType date;
	UInt16 userLength; Char *user;
	UInt16 ujLength; Char *uj;
	UInt16 passwdLength; Char *passwd;
	UInt16 subjLength; Char *subject;
	UInt16 textLength; Char *text;
	UInt16 moodNumber;
	UInt16 moodLength; Char *mood;
} Entry;

extern UserRecord *userRecords;

extern UserRecord *DelUserRecord(UserRecord * r);
extern UserRecord *GetUserRecord(UserRecord * first, UInt16 record);
extern AccessRecord *GetAccessRecord(AccessRecord * first, UInt16 record);

extern int Login(char * user, char * passwd, u_int16_t *userCount);
extern int Post(Entry *e);

#endif				/* _PALMLJ_H */
